/*
Echo string back to user.
Uses a terminator-list stopping criteria.
*/
#include <iostream>
#include <string>

/** Read a string up to any of the terminating characters 
   listed in the "stopRead" string. */
std::string readString(std::istream &in,const char *stopRead)
{
	std::string s;
	while (1) {
		char c=in.get(); /* read a char */
		if (!in) break; /* no more data to read */
		for (const char *p=stopRead;*p!=0;p++)
			if (c==*p) /* hit a stop character? */
				return s; /* done reading--return */
		
		s+=c; /* add char to string */
	}
}

int main() {
	std::string s;
	std::cout<<"Please enter your name, followed by x or newline or quote\n";
	s=readString(std::cin,"x;'\"\n");
	std::cout<<"Hello, "<<s<<"\n";
	std::cout<<"Your name is "<<s.size()<<" bytes long\n";
	return 0;
}
